 using System;
 using System.Collections.Generic;
 using System.Linq;
 using System.Text;
 using System.Threading.Tasks;
 
 using SharpCharts.Base.Data;
 using System.Xml.Serialization;
 using System.Windows.Media;
 
 namespace SharpCharts.Base.SharpScript
 {
     public class EMA : Indicator
     {
     
        public EMA() : this(14)
        { }

		public EMA(int period) : base()
        {
            this.period = period;
            this.PanelCount = 1;
        	base.Calculate = Base.SharpScript.Calculate.OnPriceChange;
        }
 
 
        protected override void OnStateChange()
        {
             
            switch (base.State)
            {
                 case State.Finalize:
                     break;
                 case State.Initialize:
                     base.AddPlot(new Plot("EMA", new LinePlotStyle(), new Pen(Brushes.Green, 2)));
                     break;
                 case State.StartUp:
                     break;
                 default:
                     break;
             }
         }
 
         protected override void OnBarUpdate()
         {
         	if (this.CurrentBar == 0)
         	{
         		Values[0][0] = Input[0];
         		return;
         	}
         	
            Values[0][0] = Input[0] * (2.0 / (1 + Period)) + (1 - (2.0 / (1 + Period))) * Values[0][1];
         }
 
         private int period = 14;
         [Input]
         public int Period
         {
             get { return period; }
             set 
             {
                 period = Math.Max(1, value);
                 NotifyPropertyChanged("Period");
             }
         }
         
         public override Common.TemplateType TemplateType
         {
             get { return Common.TemplateType.Default; }
         }
 
     }
     
     
     public static partial class AddOrGetIndicator
     {
    	public static EMA EMA(SharpScriptBase owner, int period)
    	{
    		return EMA(owner, owner.Input, period);
    	}
    	
    	public static EMA EMA(SharpScriptBase owner, ISeries<double> input, int period)
    	{
    		return CacheIndicator<EMA>(owner, input, new object[] { period });
    	}
    }
 }