using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using SharpCharts.Base.Data;
using System.Xml.Serialization;
using System.Windows.Media;
using SharpCharts.Base.ChartObject;

namespace SharpCharts.Base.SharpScript
{
    public class HMA : Indicator
    {
    
    	WMA wma1 = null;
    	WMA wma2 = null;
    	WMA wma3 = null;
    	
    	Series<double> series = null;
    	
        public HMA() : this(14)
        { }

        public HMA(int period) : base()
        {   
            this.Period = period;
            base.PanelCount = 1;
            base.Calculate = Base.SharpScript.Calculate.OnPriceChange;
        }


        protected override void OnStateChange()
        {
            
            switch (base.State)
            {
                case State.Finalize:
                    break;
                case State.Initialize:
                	AddPlot(new Plot("HMA", new LinePlotStyle(), Brushes.Green, 2));
                	this.series = new Series<double>(this);
                	
                    break;
                case State.StartUp:
                	this.wma1 = AddOrGetIndicator.WMA(this, this.Input, this.Period);
                	this.wma2 = AddOrGetIndicator.WMA(this, this.Input, this.Period / 2);
                	
                	this.wma3 = AddOrGetIndicator.WMA(this, this.series, (int)Math.Sqrt(this.Period));
                    break;
                default:
                    break;
            }
        }
		
        protected override void OnBarUpdate()
        {
            this.series[0] = 2 * this.wma2[0] - this.wma1[0];
            Values[0][0] = this.wma3[0];
        }

        private int period = 14;
        [Input]
        public int Period
        {
            get { return period; }
            set 
            {
                period = Math.Max(1, value);
                NotifyPropertyChanged("Period");
            }
        }

    }


    public static partial class AddOrGetIndicator
    {
        public static HMA HMA(SharpScriptBase owner, int period)
        {
            return HMA(owner, owner.Close, period);
        }

        public static HMA HMA(SharpScriptBase owner, ISeries<double> input, int period)
        {
            return AddOrGetIndicator.CacheIndicator<HMA>(owner, input, new object[] { period });
        }
    }
}