using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using SharpCharts.Base.Data;
using System.Xml.Serialization;
using System.Windows.Media;

namespace SharpCharts.Base.SharpScript
{
    public class SUM : Indicator
    {
    
        public SUM() : this(14)
        { }
       
        public SUM(int period) : base()
        {
            this.Period = period;        
        
            base.PanelCount = 0;
            base.Calculate = Base.SharpScript.Calculate.OnPriceChange;
        }


        protected override void OnStateChange()
        {
            
            switch (base.State)
            {
                case State.Finalize:
                    break;
                case State.Initialize:
                     AddPlot(new Plot("SUM", new LinePlotStyle(), Brushes.Blue, 2));
                    break;
                case State.StartUp:
                    break;
                default:
                    break;
            }
        }

        protected override void OnBarUpdate()
        {
        	if (CurrentBar == 0)
        	{
        		Values[0][0] = Input[0];	
        	}
        	else
        	{
        		if (CurrentBar < this.Period)
        		{
        			Values[0][0] = Input[0] + Values[0][1];
        		}
        		else
        		{
        			Values[0][0] = Input[0] + Values[0][1] - Input[this.Period];
        		}
        	}
        }

        private int period = 14;
        [Input]
        public int Period
        {
            get { return period; }
            set 
            {
                period = Math.Max(1, value);
                NotifyPropertyChanged("Period");
            }
        }
        
    }
    
    
    public static partial class AddOrGetIndicator
    {
    	public static SUM SUM(SharpScriptBase owner, int period)
    	{
    		return SUM(owner, owner.Input, period);
    	}
    	
    	public static SUM SUM(SharpScriptBase owner, ISeries<double> input, int period)
    	{
    		return AddOrGetIndicator.CacheIndicator<SUM>(owner, input, new object[] { period });
    	}
    }
}