using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using SharpCharts.Base.Data;
using System.Xml.Serialization;
using System.Windows.Media;
using SharpCharts.Base.Common;
using SharpCharts.Base.ChartObject;

namespace SharpCharts.Base.SharpScript
{
    public class HomodyneDiscriminator : Indicator
    {
    
    	HilbertTransform hilbertTransform = null;
    	
        public HomodyneDiscriminator() : base()
        {   
            base.PanelCount = 0;
            base.Calculate = Base.SharpScript.Calculate.OnPriceChange;
        }


        protected override void OnStateChange()
        {
            
            switch (base.State)
            {
                case State.Finalize:
                    break;
                case State.Initialize:
                	AddPlot(new Plot("Homodyne", new LinePlotStyle(), Brushes.Orange, 2));
                	AddLine(new Line("Zero Line"));
                    break;
                case State.StartUp:
                
                	this.hilbertTransform = AddOrGetIndicator.HilbertTransform(this, Input, 0);
                    break;
                default:
                    break;
            }
        }

        protected override void OnBarUpdate()
        {
            Values[0][0] = this.hilbertTransform.CycleSmoothPeriod[0];
        }

		[XmlIgnore]
        public ISeries<double> Homodyne
        {
        	get { return Values[0]; }
        }
		
		
		public override TemplateType TemplateType 
		{
			get { return TemplateType.None; }
		}
    }
    
    public static partial class AddOrGetIndicator
    {
    	public static HomodyneDiscriminator HomodyneDiscriminator(SharpScriptBase owner)
    	{
    		return HomodyneDiscriminator(owner, owner.Input);
    	}
    	
    	public static HomodyneDiscriminator HomodyneDiscriminator(SharpScriptBase owner, ISeries<double> input)
    	{
    		return CacheIndicator<HomodyneDiscriminator>(owner, input);
    	}
    }
}