using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using SharpCharts.Base.Data;
using System.Xml.Serialization;
using System.Windows.Media;
using SharpCharts.Base.ChartObject;

namespace SharpCharts.Base.SharpScript
{
    public class SMMA : Indicator
    {
    
    	double smma1 = 0;
		double sum1	= 0;
		double prevsum1 = 0;
		double prevsmma1 = 0;
    
    	SUM sum = null;
        public SMMA() : this(14)
        { }

        public SMMA(int period) : base()
        {   
            this.Period = period;
            base.PanelCount = 1;
            base.Calculate = Base.SharpScript.Calculate.OnPriceChange;
        }


        protected override void OnStateChange()
        {
            
            switch (base.State)
            {
                case State.Finalize:
                    break;
                case State.Initialize:
                	AddPlot(new Plot("SMMA", new LinePlotStyle(), Brushes.Green, 2));
                    break;
                case State.StartUp:
                	this.sum = AddOrGetIndicator.SUM(this, this.Input, this.period);
                    break;
                default:
                    break;
            }
        }

        protected override void OnBarUpdate()
        {
        	
            if (CurrentBar == this.Period)
			{
				this.sum1 = this.sum[0];
				this.smma1 = this.sum1 / this.Period;
				
				Values[0][0] = this.smma1;				
			}
			else if (CurrentBar > Period)
			{
				if (this.IsFirstTickOfBar)
				{
					this.prevsum1 = this.sum1;
					this.prevsmma1 = this.smma1;
				}
				
				Values[0][0] = (this.prevsum1 - this.prevsmma1 + Input[0]) / this.Period;
				this.sum1 = this.prevsum1 - this.prevsmma1 + Input[0];
				this.smma1 = (this.sum1 - this.prevsmma1 + Input[0]) / this.Period;
			}
        }

        private int period = 14;
        [Input]
        public int Period
        {
            get { return period; }
            set 
            {
                period = Math.Max(1, value);
                NotifyPropertyChanged("Period");
            }
        }

    }
    
    
    public static partial class AddOrGetIndicator
     {
    	public static SMMA SMMA(SharpScriptBase owner, int period)
    	{
    		return SMMA(owner, owner.Input, period);
    	}
    	
    	public static SMMA SMMA(SharpScriptBase owner, ISeries<double> input, int period)
    	{
    		return CacheIndicator<SMMA>(owner, input, new object[] { period });
    	}
    }
    
    
}